class HelpTopicTest
Same name in this branch
- 11.x core/modules/help/tests/src/Functional/HelpTopicTest.php \Drupal\Tests\help\Functional\HelpTopicTest
Same name and namespace in other branches
- 9 core/modules/help_topics/tests/src/Functional/HelpTopicTest.php \Drupal\Tests\help_topics\Functional\HelpTopicTest
- 8.9.x core/modules/help_topics/tests/src/Functional/HelpTopicTest.php \Drupal\Tests\help_topics\Functional\HelpTopicTest
- 10 core/modules/help/tests/src/Functional/HelpTopicTest.php \Drupal\Tests\help\Functional\HelpTopicTest
Verifies help topic display and user access to help based on permissions.
Attributes
#[Group('help')]
#[RunTestsInSeparateProcesses]
Hierarchy
- class \Drupal\KernelTests\KernelTestBase implements \Drupal\Core\DependencyInjection\ServiceProviderInterface uses \Drupal\Tests\DrupalTestCaseTrait, \Drupal\KernelTests\AssertContentTrait, \Drupal\Tests\RandomGeneratorTrait, \Drupal\Tests\ConfigTestTrait, \Drupal\Tests\ExtensionListTestTrait, \Drupal\Tests\PhpUnitCompatibilityTrait, \Prophecy\PhpUnit\ProphecyTrait, \Drupal\TestTools\Extension\DeprecationBridge\ExpectDeprecationTrait, \Drupal\Tests\BrowserHtmlDebugTrait, \Drupal\Tests\HttpKernelUiHelperTrait extends \PHPUnit\Framework\TestCase
Expanded class hierarchy of HelpTopicTest
File
-
core/
modules/ help/ tests/ src/ Kernel/ HelpTopicTest.php, line 19
Namespace
Drupal\Tests\help\KernelView source
class HelpTopicTest extends KernelTestBase {
use AssertBreadcrumbTrait;
use BlockCreationTrait;
use HttpKernelUiHelperTrait;
use UserCreationTrait;
/**
* {@inheritdoc}
*/
protected static $modules = [
'help_topics_test',
'help',
'block',
'user',
'system',
'path_alias',
];
/**
* The admin user that will be created.
*
* @var \Drupal\user\UserInterface
*/
protected $adminUser;
/**
* The user who can see help but not the special route.
*
* @var \Drupal\user\UserInterface
*/
protected $noTestUser;
/**
* The anonymous user that will be created.
*
* @var \Drupal\user\UserInterface
*/
protected $anyUser;
/**
* {@inheritdoc}
*/
public function register(ContainerBuilder $container) : void {
parent::register($container);
$container->setParameter('http.response.debug_cacheability_headers', TRUE);
}
/**
* {@inheritdoc}
*/
protected function setUp() : void {
parent::setUp();
$this->installEntitySchema('path_alias');
$this->installEntitySchema('user');
$this->installSchema('user', [
'users_data',
]);
$this->installConfig('system');
$this->config('system.site')
->set('name', 'Drupal')
->save();
// These tests rely on some markup from the 'stark' theme and we test theme
// provided help topics.
\Drupal::service('theme_installer')->install([
'help_topics_test_theme',
'stark',
]);
$this->config('system.theme')
->set('default', 'stark')
->save();
// Place various blocks.
$settings = [
'theme' => 'stark',
'region' => 'help',
];
$this->placeBlock('help_block', $settings);
$this->placeBlock('local_tasks_block', $settings);
$this->placeBlock('local_actions_block', $settings);
$this->placeBlock('page_title_block', $settings);
$this->placeBlock('system_breadcrumb_block', $settings);
// Create users.
$this->adminUser = $this->createUser([
'access administration pages',
'access help pages',
'view the administration theme',
'administer permissions',
'administer site configuration',
'access test help',
]);
$this->noTestUser = $this->createUser([
'access help pages',
'view the administration theme',
'administer permissions',
'administer site configuration',
]);
$this->anyUser = $this->createUser();
}
/**
* Tests the main help page and individual pages for topics.
*/
public function testHelp() : void {
$session = $this->assertSession();
// Log in the regular user.
$this->setCurrentUser($this->anyUser);
$this->verifyHelp(403);
// Log in the admin user.
$this->setCurrentUser($this->adminUser);
$this->verifyHelp();
$this->verifyBreadCrumb();
// Verify that help topics text appears on admin/help, and cache tags.
$this->drupalGet('/admin/help');
$session->responseContains('<h2 id="help-topics">Topics</h2>');
$session->pageTextContains('Topics can be provided by modules or themes');
$session->responseHeaderContains('X-Drupal-Cache-Tags', 'core.extension');
// Verify links for help topics and order.
$page_text = $this->getTextContent();
$start = strpos($page_text, 'Topics can be provided');
$pos = $start;
foreach ($this->getTopicList() as $info) {
$name = $info['name'];
$session->linkExists($name);
$new_pos = strpos($page_text, $name, $start);
$this->assertGreaterThan($pos, $new_pos, "Order of {$name} is not correct on page");
$pos = $new_pos;
}
// Ensure the plugin manager alter hook works as expected.
$session->linkExists('ABC Help Test module');
\Drupal::state()->set('help_topics_test.test:top_level', FALSE);
\Drupal::service('plugin.manager.help_topic')->clearCachedDefinitions();
$this->drupalGet('admin/help');
$session->linkNotExists('ABC Help Test module');
\Drupal::state()->set('help_topics_test.test:top_level', TRUE);
\Drupal::service('plugin.manager.help_topic')->clearCachedDefinitions();
$this->drupalGet('admin/help');
// Ensure all the expected links are present before uninstalling.
$session->linkExists('ABC Help Test module');
$session->linkExists('ABC Help Test');
$session->linkExists('XYZ Help Test theme');
// Uninstall the test module and verify the topics are gone, after
// reloading page.
$this->container
->get('module_installer')
->uninstall([
'help_topics_test',
]);
$this->drupalGet('admin/help');
$session->linkNotExists('ABC Help Test module');
$session->linkNotExists('ABC Help Test');
$session->linkExists('XYZ Help Test theme');
// Uninstall the test theme and verify the topic is gone.
$this->container
->get('theme_installer')
->uninstall([
'help_topics_test_theme',
]);
$this->drupalGet('admin/help');
$session->linkNotExists('XYZ Help Test theme');
}
/**
* Verifies the logged in user has access to various help links and pages.
*
* @param int $response
* (optional) The HTTP response code to test for. If it's 200 (default),
* the test verifies the user sees the help; if it's not, it verifies they
* are denied access.
*/
protected function verifyHelp($response = 200) : void {
// Verify access to help topic pages.
foreach ($this->getTopicList() as $topic => $info) {
// View help topic page.
$this->drupalGet('admin/help/topic/' . $topic);
$session = $this->assertSession();
$session->statusCodeEquals($response);
if ($response == 200) {
// Verify page information.
$name = $info['name'];
$session->titleEquals($name . ' | Drupal');
$session->responseContains('<h1>' . $name . '</h1>');
foreach ($info['tags'] as $tag) {
$session->responseHeaderContains('X-Drupal-Cache-Tags', $tag);
}
}
}
}
/**
* Verifies links on various topic pages.
*/
public function testHelpLinks() : void {
$session = $this->assertSession();
$this->setCurrentUser($this->adminUser);
// Verify links on the test top-level page.
$page = 'admin/help/topic/help_topics_test.test';
// Array element is the page text if you click through.
$links = [
'Linked topic' => 'This topic is not supposed to be top-level',
'Additional topic' => 'This topic should get listed automatically',
'URL test topic' => 'It is used to test URLs',
];
foreach ($links as $link_text => $page_text) {
$this->drupalGet($page);
$this->clickLink($link_text);
$session->pageTextContains($page_text);
}
// Verify theme provided help topics work and can be related.
$this->drupalGet('admin/help/topic/help_topics_test_theme.test');
$session->pageTextContains('This is a theme provided topic.');
$this->assertStringContainsString('This is a theme provided topic.', $session->elementExists('css', 'article')
->getText());
$this->clickLink('Additional topic');
$session->linkExists('XYZ Help Test theme');
// Verify that the non-top-level topics do not appear on the Help page.
$this->drupalGet('admin/help');
$session->linkNotExists('Linked topic');
$session->linkNotExists('Additional topic');
// Verify links and non-links on the URL test page.
$this->drupalGet('admin/help/topic/help_topics_test.test_urls');
$links = [
'not a route' => FALSE,
'missing params' => FALSE,
'invalid params' => FALSE,
'valid link' => TRUE,
'Additional topic' => TRUE,
'Missing help topic not_a_topic' => FALSE,
];
foreach ($links as $text => $should_be_link) {
if ($should_be_link) {
$session->linkExists($text);
}
else {
// Should be text that is not a link.
$session->pageTextContains($text);
$session->linkNotExists($text);
}
}
// Verify that the "no test" user, who should not be able to access
// the 'valid link' URL, sees it as not a link.
$this->setCurrentUser($this->noTestUser);
$this->drupalGet('admin/help/topic/help_topics_test.test_urls');
$session->pageTextContains('valid link');
$session->linkNotExists('valid link');
}
/**
* Gets a list of topic IDs to test.
*
* @return array
* A list of topics to test, in the order in which they should appear. The
* keys are the machine names of the topics. The values are arrays with the
* following elements:
* - name: Displayed name.
* - tags: Cache tags to test for.
*/
protected function getTopicList() {
return [
'help_topics_test.test' => [
'name' => 'ABC Help Test module',
'tags' => [
'core.extension',
],
],
'help_topics_derivatives:test_derived_topic' => [
'name' => 'Label for test_derived_topic',
'tags' => [
'foobar',
],
],
'help_topics_test_direct_yml' => [
'name' => 'Test direct yaml topic label',
'tags' => [
'foobar',
],
],
];
}
/**
* Tests breadcrumb on a help topic page.
*/
public function verifyBreadCrumb() : void {
// Verify Help Topics administration breadcrumbs.
$trail = [
'' => 'Home',
'admin' => 'Administration',
'admin/help' => 'Help',
];
$this->assertBreadcrumb('/admin/help/topic/help_topics_test.test', $trail);
// Ensure we are on the expected help topic page.
$this->assertSession()
->pageTextContains('Also there should be a related topic link below to the Help module topic page and the linked topic.');
// Verify that another page does not have the help breadcrumb.
$trail = [
'' => 'Home',
'admin' => 'Administration',
'admin/config' => 'Configuration',
'admin/config/system' => 'System',
];
$this->assertBreadcrumb('/admin/config/system/site-information', $trail);
}
}
Members
| Title Sort descending | Deprecated | Modifiers | Object type | Summary | Overriden Title | Overrides |
|---|---|---|---|---|---|---|
| AssertBreadcrumbTrait::assertBreadcrumb | protected | function | Assert that a given path shows certain breadcrumb links. | |||
| AssertBreadcrumbTrait::assertBreadcrumbParts | protected | function | Assert that a trail exists in the internal browser. | |||
| AssertBreadcrumbTrait::getBreadcrumbParts | protected | function | Returns the breadcrumb contents of the current page in the internal browser. | |||
| AssertContentTrait::$content | protected | property | The current raw content. | |||
| AssertContentTrait::$drupalSettings | protected | property | The drupalSettings value from the current raw $content. | |||
| AssertContentTrait::$elements | protected | property | The XML structure parsed from the current raw $content. | 1 | ||
| AssertContentTrait::$plainTextContent | protected | property | The plain-text content of raw $content (text nodes). | |||
| AssertContentTrait::assertEscaped | protected | function | Passes if the raw text IS found escaped on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertField | protected | function | Asserts that a field exists with the given name or ID. | |||
| AssertContentTrait::assertFieldById | Deprecated | protected | function | Asserts that a field exists with the given ID and value. | ||
| AssertContentTrait::assertFieldByName | protected | function | Asserts that a field exists with the given name and value. | |||
| AssertContentTrait::assertFieldByXPath | protected | function | Asserts that a field exists in the current page by the given XPath. | |||
| AssertContentTrait::assertFieldChecked | Deprecated | protected | function | Asserts that a checkbox field in the current page is checked. | ||
| AssertContentTrait::assertFieldsByValue | protected | function | Asserts that a field exists in the current page with a given Xpath result. | |||
| AssertContentTrait::assertLink | protected | function | Passes if a link with the specified label is found. | |||
| AssertContentTrait::assertLinkByHref | protected | function | Passes if a link containing a given href (part) is found. | |||
| AssertContentTrait::assertNoDuplicateIds | Deprecated | protected | function | Asserts that each HTML ID is used for just a single element. | ||
| AssertContentTrait::assertNoEscaped | protected | function | Passes if raw text IS NOT found escaped on loaded page, fail otherwise. | |||
| AssertContentTrait::assertNoField | Deprecated | protected | function | Asserts that a field does not exist with the given name or ID. | ||
| AssertContentTrait::assertNoFieldById | Deprecated | protected | function | Asserts that a field does not exist with the given ID and value. | ||
| AssertContentTrait::assertNoFieldByName | Deprecated | protected | function | Asserts that a field does not exist with the given name and value. | ||
| AssertContentTrait::assertNoFieldByXPath | Deprecated | protected | function | Asserts that a field does not exist or its value does not match, by XPath. | ||
| AssertContentTrait::assertNoFieldChecked | Deprecated | protected | function | Asserts that a checkbox field in the current page is not checked. | ||
| AssertContentTrait::assertNoLink | protected | function | Passes if a link with the specified label is not found. | |||
| AssertContentTrait::assertNoLinkByHref | Deprecated | protected | function | Passes if a link containing a given href (part) is not found. | ||
| AssertContentTrait::assertNoLinkByHrefInMainRegion | Deprecated | protected | function | Passes if a link containing a given href is not found in the main region. | ||
| AssertContentTrait::assertNoOption | Deprecated | protected | function | Asserts that a select option in the current page does not exist. | ||
| AssertContentTrait::assertNoOptionSelected | Deprecated | protected | function | Asserts that a select option in the current page is not checked. | ||
| AssertContentTrait::assertNoPattern | protected | function | Triggers a pass if the perl regex pattern is not found in raw content. | |||
| AssertContentTrait::assertNoRaw | protected | function | Passes if the raw text is NOT found on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertNoText | protected | function | Passes if the page (with HTML stripped) does not contains the text. | |||
| AssertContentTrait::assertNoTitle | protected | function | Pass if the page title is not the given string. | |||
| AssertContentTrait::assertNoUniqueText | Deprecated | protected | function | Passes if the text is found MORE THAN ONCE on the text version of the page. | ||
| AssertContentTrait::assertOption | protected | function | Asserts that a select option in the current page exists. | |||
| AssertContentTrait::assertOptionByText | Deprecated | protected | function | Asserts that a select option with the visible text exists. | ||
| AssertContentTrait::assertOptionSelected | Deprecated | protected | function | Asserts that a select option in the current page is checked. | ||
| AssertContentTrait::assertOptionSelectedWithDrupalSelector | Deprecated | protected | function | Asserts that a select option in the current page is checked. | ||
| AssertContentTrait::assertOptionWithDrupalSelector | protected | function | Asserts that a select option in the current page exists. | |||
| AssertContentTrait::assertPattern | protected | function | Triggers a pass if the Perl regex pattern is found in the raw content. | |||
| AssertContentTrait::assertRaw | protected | function | Passes if the raw text IS found on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertText | protected | function | Passes if the page (with HTML stripped) contains the text. | |||
| AssertContentTrait::assertTextHelper | protected | function | Helper for assertText and assertNoText. | |||
| AssertContentTrait::assertTextPattern | Deprecated | protected | function | Asserts that a Perl regex pattern is found in the plain-text content. | ||
| AssertContentTrait::assertThemeOutput | protected | function | Asserts themed output. | |||
| AssertContentTrait::assertTitle | protected | function | Pass if the page title is the given string. | |||
| AssertContentTrait::assertUniqueText | Deprecated | protected | function | Passes if the text is found ONLY ONCE on the text version of the page. | ||
| AssertContentTrait::assertUniqueTextHelper | Deprecated | protected | function | Helper for assertUniqueText and assertNoUniqueText. | ||
| AssertContentTrait::buildXPathQuery | protected | function | Builds an XPath query. | |||
| AssertContentTrait::constructFieldXpath | protected | function | Helper: Constructs an XPath for the given set of attributes and value. | |||
| AssertContentTrait::cssSelect | protected | function | Searches elements using a CSS selector in the raw content. | |||
| AssertContentTrait::getAllOptions | protected | function | Get all option elements, including nested options, in a select. | |||
| AssertContentTrait::getDrupalSettings | protected | function | Gets the value of drupalSettings for the currently-loaded page. | |||
| AssertContentTrait::getRawContent | protected | function | Gets the current raw content. | |||
| AssertContentTrait::getSelectedItem | protected | function | Get the selected value from a select field. | |||
| AssertContentTrait::getTextContent | protected | function | Retrieves the plain-text content from the current raw content. | |||
| AssertContentTrait::parse | protected | function | Parse content returned from curlExec using DOM and SimpleXML. | |||
| AssertContentTrait::removeWhiteSpace | protected | function | Removes all white-space between HTML tags from the raw content. | |||
| AssertContentTrait::setDrupalSettings | protected | function | Sets the value of drupalSettings for the currently-loaded page. | |||
| AssertContentTrait::setRawContent | protected | function | Sets the raw content (e.g. HTML). | |||
| AssertContentTrait::xpath | protected | function | Performs an xpath search on the contents of the internal browser. | |||
| AssertMenuActiveTrailTrait::assertMenuActiveTrail | protected | function | Assert that active trail exists in a menu tree output. | |||
| BlockCreationTrait::placeBlock | protected | function | Creates a block instance based on default settings. | |||
| BrowserHtmlDebugTrait::$htmlOutputBaseUrl | protected | property | The Base URI to use for links to the output files. | |||
| BrowserHtmlDebugTrait::$htmlOutputClassName | protected | property | Class name for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputCounter | protected | property | Counter for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputCounterStorage | protected | property | Counter storage for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputDirectory | protected | property | Directory name for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputEnabled | protected | property | HTML output enabled. | |||
| BrowserHtmlDebugTrait::$htmlOutputTestId | protected | property | HTML output test ID. | |||
| BrowserHtmlDebugTrait::formatHtmlOutputHeaders | protected | function | Formats HTTP headers as string for HTML output logging. | |||
| BrowserHtmlDebugTrait::getHtmlOutputHeaders | protected | function | Returns headers in HTML output format. | 1 | ||
| BrowserHtmlDebugTrait::getResponseLogHandler | protected | function | Provides a Guzzle middleware handler to log every response received. | |||
| BrowserHtmlDebugTrait::getTestMethodCaller | protected | function | Retrieves the current calling line in the class under test. | 1 | ||
| BrowserHtmlDebugTrait::htmlOutput | protected | function | Logs a HTML output message in a text file. | |||
| BrowserHtmlDebugTrait::initBrowserOutputFile | protected | function | Creates the directory to store browser output. | |||
| ConfigTestTrait::configImporter | protected | function | Returns a ConfigImporter object to import test configuration. | |||
| ConfigTestTrait::copyConfig | protected | function | Copies configuration objects from source storage to target storage. | |||
| DrupalTestCaseTrait::$root | protected | property | The Drupal root directory. | |||
| DrupalTestCaseTrait::checkErrorHandlerOnTearDown | public | function | Checks the test error handler after test execution. | 1 | ||
| DrupalTestCaseTrait::getDrupalRoot | Deprecated | protected static | function | Returns the Drupal root directory. | 1 | |
| DrupalTestCaseTrait::setDebugDumpHandler | public static | function | Registers the dumper CLI handler when the DebugDump extension is enabled. | |||
| DrupalTestCaseTrait::setUpRoot | final protected | function | Ensure that the $root property is set initially. | |||
| ExpectDeprecationTrait::expectDeprecation | Deprecated | public | function | Adds an expected deprecation. | ||
| ExpectDeprecationTrait::regularExpressionForFormatDescription | private | function | ||||
| ExtensionListTestTrait::getModulePath | protected | function | Gets the path for the specified module. | |||
| ExtensionListTestTrait::getThemePath | protected | function | Gets the path for the specified theme. | |||
| HelpTopicTest::$adminUser | protected | property | The admin user that will be created. | |||
| HelpTopicTest::$anyUser | protected | property | The anonymous user that will be created. | |||
| HelpTopicTest::$modules | protected static | property | Modules to install. | Overrides KernelTestBase::$modules | ||
| HelpTopicTest::$noTestUser | protected | property | The user who can see help but not the special route. | |||
| HelpTopicTest::getTopicList | protected | function | Gets a list of topic IDs to test. | |||
| HelpTopicTest::register | public | function | Registers test-specific services. | Overrides KernelTestBase::register | ||
| HelpTopicTest::setUp | protected | function | Overrides KernelTestBase::setUp | |||
| HelpTopicTest::testHelp | public | function | Tests the main help page and individual pages for topics. | |||
| HelpTopicTest::testHelpLinks | public | function | Verifies links on various topic pages. | |||
| HelpTopicTest::verifyBreadCrumb | public | function | Tests breadcrumb on a help topic page. | |||
| HelpTopicTest::verifyHelp | protected | function | Verifies the logged in user has access to various help links and pages. | |||
| HttpKernelUiHelperTrait::$mink | protected | property | Mink session manager. | |||
| HttpKernelUiHelperTrait::assertSession | public | function | Returns WebAssert object. | |||
| HttpKernelUiHelperTrait::buildUrl | protected | function | Builds a URL from a system path or a URL object. | |||
| HttpKernelUiHelperTrait::clickLink | protected | function | Follows a link by complete name. | |||
| HttpKernelUiHelperTrait::drupalGet | protected | function | Retrieves a Drupal path. | |||
| HttpKernelUiHelperTrait::getDefaultDriverInstance | protected | function | Gets an instance of the default Mink driver. | |||
| HttpKernelUiHelperTrait::getNodeElementsByXpath | protected | function | Performs an xpath search on the contents of the internal browser. | |||
| HttpKernelUiHelperTrait::getSession | public | function | Returns Mink session. | |||
| HttpKernelUiHelperTrait::getUrl | protected | function | Gets the current URL from the browser. | |||
| HttpKernelUiHelperTrait::initMink | protected | function | Initializes Mink sessions. | |||
| KernelTestBase::$classLoader | protected | property | The class loader. | |||
| KernelTestBase::$configImporter | protected | property | The configuration importer. | 6 | ||
| KernelTestBase::$configSchemaCheckerExclusions | protected static | property | An array of config object names that are excluded from schema checking. | 4 | ||
| KernelTestBase::$container | protected | property | The test container. | |||
| KernelTestBase::$databasePrefix | protected | property | The test database prefix. | |||
| KernelTestBase::$keyValue | protected | property | The key_value service that must persist between container rebuilds. | |||
| KernelTestBase::$siteDirectory | protected | property | The relative path to the test site directory. | |||
| KernelTestBase::$strictConfigSchema | protected | property | Set to TRUE to strict check all configuration saved. | 10 | ||
| KernelTestBase::$usesSuperUserAccessPolicy | protected | property | Set to TRUE to make user 1 a super user. | 1 | ||
| KernelTestBase::$vfsRoot | protected | property | The virtual filesystem root directory. | |||
| KernelTestBase::assertPostConditions | protected | function | 1 | |||
| KernelTestBase::bootEnvironment | protected | function | Bootstraps a basic test environment. | |||
| KernelTestBase::bootKernel | protected | function | Bootstraps a kernel for a test. | 1 | ||
| KernelTestBase::config | protected | function | Configuration accessor for tests. Returns non-overridden configuration. | |||
| KernelTestBase::disableModules | protected | function | Disables modules for this test. | |||
| KernelTestBase::enableModules | protected | function | Enables modules for this test. | 2 | ||
| KernelTestBase::getConfigSchemaExclusions | protected | function | Gets the config schema exclusions for this test. | |||
| KernelTestBase::getDatabaseConnectionInfo | protected | function | Returns the Database connection info to be used for this test. | 3 | ||
| KernelTestBase::getDatabasePrefix | public | function | Gets the database prefix used for test isolation. | |||
| KernelTestBase::getExtensionsForModules | private | function | Returns Extension objects for $modules to install. | |||
| KernelTestBase::getModulesToEnable | protected static | function | Returns the modules to install for this test. | |||
| KernelTestBase::initFileCache | protected | function | Initializes the FileCache component. | |||
| KernelTestBase::installConfig | protected | function | Installs default configuration for a given list of modules. | |||
| KernelTestBase::installEntitySchema | protected | function | Installs the storage schema for a specific entity type. | |||
| KernelTestBase::installSchema | protected | function | Installs database tables from a module schema definition. | |||
| KernelTestBase::render | protected | function | Renders a render array. | 1 | ||
| KernelTestBase::setInstallProfile | protected | function | Sets the install profile and rebuilds the container to update it. | |||
| KernelTestBase::setSetting | protected | function | Sets an in-memory Settings variable. | |||
| KernelTestBase::setUpFilesystem | protected | function | Sets up the filesystem, so things like the file directory. | 3 | ||
| KernelTestBase::tearDown | protected | function | 10 | |||
| KernelTestBase::tearDownCloseDatabaseConnection | public | function | Additional tear down method to close the connection at the end. | |||
| KernelTestBase::vfsDump | protected | function | Dumps the current state of the virtual filesystem to STDOUT. | |||
| KernelTestBase::__construct | public | function | ||||
| KernelTestBase::__sleep | public | function | Prevents serializing any properties. | |||
| RandomGeneratorTrait::getRandomGenerator | protected | function | Gets the random generator for the utility methods. | |||
| RandomGeneratorTrait::randomMachineName | protected | function | Generates a unique random string containing letters and numbers. | |||
| RandomGeneratorTrait::randomObject | public | function | Generates a random PHP object. | |||
| RandomGeneratorTrait::randomString | public | function | Generates a pseudo-random string of ASCII characters of codes 32 to 126. | |||
| StorageCopyTrait::replaceStorageContents | protected static | function | Copy the configuration from one storage to another and remove stale items. | |||
| UserCreationTrait::checkPermissions | protected | function | Checks whether a given list of permission names is valid. | |||
| UserCreationTrait::createAdminRole | protected | function | Creates an administrative role. | |||
| UserCreationTrait::createRole | protected | function | Creates a role with specified permissions. | |||
| UserCreationTrait::createUser | protected | function | Create a user with a given set of permissions. | 1 | ||
| UserCreationTrait::grantPermissions | protected | function | Grant permissions to a user role. | |||
| UserCreationTrait::setCurrentUser | protected | function | Switch the current logged in user. | |||
| UserCreationTrait::setUpCurrentUser | protected | function | Creates a random user account and sets it as current user. |
Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.